package simplegenerator.dto;

import java.io.IOException;
import java.util.Collections;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.emf.common.util.BasicMonitor;
import org.eclipse.emf.common.util.URI;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IFileEditorInput;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;

import simplegenerator.acceleo.main.Workflow;

public class AcceleoCommand extends org.eclipse.core.commands.AbstractHandler {

	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		IWorkbench iworkbench = PlatformUI.getWorkbench();
		IWorkbenchWindow iworkbenchwindow = iworkbench.getActiveWorkbenchWindow();
		IWorkbenchPage iworkbenchpage = iworkbenchwindow.getActivePage();
		IEditorPart ieditorpart = iworkbenchpage.getActiveEditor();
		
		IFile editorInput = ((IFileEditorInput)ieditorpart.getEditorInput()).getFile();
		IFolder folder = editorInput.getProject().getFolder("src-gen");

		try {
			Workflow wf = new Workflow(
					URI.createFileURI(editorInput.getFullPath().toString()), 
					folder.getFullPath().toFile(), 
					Collections.emptyList());
			wf.doGenerate(new BasicMonitor());
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		
		return null;
	}

	@Override
	public boolean isEnabled() {
		return true;
	}

}
